<?php defined('SYSPATH') || die('No direct script access.');

class Model_Group extends Model
{
    private $ID;

    public function getID() {
        return $this->ID;
    }

    public static function with($id) {
        $g = new self();
        $g->ID = (int) $id;
        return $g;
    }

    public static function findOrCreate($gradeID, $groupNum, $specialization, $facultyID, $year, $form) {
        $sql = 'SELECT * FROM CreateGroup(:gradeID, :groupNum, :specialization, :facultyID, :year, :form) AS "ID"';
        $id = DB::query(Database::SELECT, $sql)
            ->param(':gradeID', $gradeID)
            ->param(':groupNum', (int)$groupNum)
            ->param(':specialization', $specialization)
            ->param(':facultyID', $facultyID)
            ->param(':year', $year)
            ->param(':form', $form)
            ->execute()->get('ID');
        if ($id <= 0) {
            return null;
        }
        return Model_Group::with((int)$id);
    }

    public static function find($gradeID, $groupNum, $formID, $facultyID) {
        $sql = 'SELECT * FROM FindGroup(:gradeID, :groupNum, :form, :facultyID) AS "ID"';
        $id = DB::query(Database::SELECT, $sql)
            ->param(':gradeID', $gradeID)
            ->param(':groupNum', (int)$groupNum)
            ->param(':form', $formID)
            ->param(':facultyID', $facultyID)
            ->execute()->get('ID');
        if ($id <= 0) {
            return null;
        }
        return $id;
    }

    /** @return Model_Discipline[] */
    public function getDisciplines($lazy = true, $semesterID = null) {
        $semesterID = $semesterID ?: User::instance()->SemesterID;
        $sql = 'SELECT * FROM GetDisciplinesForGroup(:id, :semesterID)';
        $query = DB::query(Database::SELECT, $sql)
            ->param(':id', $this->ID)
            ->param(':semesterID', $semesterID)
            ->execute();

        $list = [];
        foreach ($query as $data)
            $list[] = new Model_Discipline($data, true, $lazy);

        return $list;
    }
}
